#!/usr/bin/perl

##  bose - a Lightweight Workflow Engine
##  Copyright (C) 2006  Kunimasa Noda <kuni@_flow_pm9.com>
##
##  SPL - The SPL Programming Language
##  Copyright (C) 2004, 2005  Clifford Wolf <clifford@_flow_clifford.at>
##
##  This program is free software; you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation; either version 2 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License
##  along with this program; if not, write to the Free Software
##  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##
##  bose_dispatcher.pl: Workflow Engine Dispatcher

chdir("/usr/local/bose");

use POSIX 'strftime';
use DBI;
use Date::Manip;

## SNAPSHOTǼ (file / db)
$_flow_snapshot_mode = "file";

## SNAPSHOTե̾ץեå
$_flow_snapshot_file_prefix = '/usr/local/bose/tmp/bose.tmp.';

## եץȥեǼǥ쥯ȥ
$_flow_script_dir = '/tmp';

## ¹ԻĶå -- 
sub checkFreeMem {
  open(DAT, "/proc/meminfo");
  while(<DAT>) {
    if ($_ =~ m/^MemTotal:\s+([0-9]+)\s/i) { 
      $_flow_MemTotal = $1, "\n";
    }
    if ($_ =~ m/^MemFree:\s+([0-9]+)\s/i) { 
      $_flow_MemFree = $1, "\n";
    }
    if ($_ =~ m/^MemShared:\s+([0-9]+)\s/i) { 
      $_flow_MemShared = $1, "\n";
    }
    if ($_ =~ m/^Buffers:\s+([0-9]+)\s/i) { 
      $_flow_Buffers = $1, "\n";
    }
    if ($_ =~ m/^Cached:\s+([0-9]+)\s/i) { 
      $_flow_Cached = $1, "\n";
    }
  }
  close(DAT); 
  $_flow_free = int(($_flow_MemFree + $_flow_Buffers + $_flow_Cached) / 1000);
  return $_flow_free;
}

## ¹ԻĶå -- disk
sub checkFreeDisk {
  $_flow_partition = $_[0];
  open(DAT, "df -k $_flow_partition |"); 
  while(<DAT>) {
    $_flow_line = $_;
  }
  close(DAT); 
  $_flow_line =~ m/^([A-Za-z0-9\/]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+/i;
  $_flow_free = int($_flow_4 / 1000);
  return $_flow_free;
}

## DBμ
sub db_desc_trim {
  $_[0] =~ m/^([A-Za-z0-9_.]*)/;
  return $1;
}

$_flow_db_define_file = "/usr/local/bose/env/db.ini";
open(FH, $_flow_db_define_file);
$_flow_db_host = db_desc_trim($_flow_line=<FH>);
$_flow_db_port = db_desc_trim($_flow_line=<FH>);
$_flow_db_name = db_desc_trim($_flow_line=<FH>);
$_flow_db_user = db_desc_trim($_flow_line=<FH>);
$_flow_db_pass = db_desc_trim($_flow_line=<FH>);
$_flow_dbh = DBI->connect("DBI:mysql:$_flow_db_name:$_flow_db_host", $_flow_db_user, $_flow_db_pass);

## λ
$_flow_loop_main = 1;
$_flow_SIG{'INT'} = sub { $_flow_loop_main = 0; };
$_flow_SIG{'TERM'} = sub { $_flow_loop_main = 0; };
$_flow_SIG{'ALRM'} = sub { $_flow_loop_main = 0; };

## ¹ԻĶåߥ
$_flow_env_check_timing = 0;

## Dispatch Loop
while($_flow_loop_main==1) {

  ## 塼뤵줿եץγͽ
  $_flow_res = $_flow_dbh->selectall_arrayref("select QUE_NO, QUE_ENTRY_TIME, TIME_CONDITION from tbl_BOSE_QUE where DUE_TIME<'0000/01/01'");

  foreach(@$_flow_res) {
    eval($_->[2]);
    $_flow_act_que_no = $_->[0];
    $_flow_dbh->do("update tbl_BOSE_QUE set DUE_TIME='$flow_start_time' where QUE_NO='$_flow_act_que_no'");
  }


  ## ¹ԴĶå
  $_flow_loop = 1;

  $_flow_env_check_timing++;
  if ($_flow_env_check_timing > 10) {
    $_flow_env_check_timing = 0;
  }
  if ($_flow_env_check_timing == 0) {
    if (checkFreeMem() < 10) {
      select undef, undef, undef, 10;
      $_flow_loop = 0;
    }

    if (checkFreeDisk('/') < 100) {
      select undef, undef, undef, 10;
      $_flow_loop = 0;
    }
  }

  ## ͽ郎߻ãեץεư
  while($_flow_loop_main==1 && $_flow_loop==1) {
  
    ## ʣHOSTǤDispatcherƱ¹ݾ
    $_flow_dbh->do("lock tables tbl_BOSE_QUE write, tbl_BOSE_PROC_STAT write, tbl_BOSE_LOCK write, tbl_BOSE_WORKFLOW write");

    ## եץ
    ##@_flow_que_rec = $_flow_dbh->selectrow_array("select PROCESS_ID, QUE_NO from tbl_BOSE_QUE where DUE_TIME<=NOW() and DUE_TIME>'0000/01/01' and ACTIVATE_FG='1' and INWORK_FG='' order by DUE_TIME, QUE_NO");

    @_flow_que_rec = $_flow_dbh->selectrow_array("select tbl_BOSE_QUE.PROCESS_ID, tbl_BOSE_QUE.QUE_NO, tbl_BOSE_QUE.LOCK_ID from tbl_BOSE_QUE left join tbl_BOSE_LOCK on tbl_BOSE_QUE.LOCK_ID=tbl_BOSE_LOCK.LOCK_ID WHERE tbl_BOSE_QUE.DUE_TIME<=NOW() and tbl_BOSE_QUE.DUE_TIME>'0000/01/01' and tbl_BOSE_QUE.ACTIVATE_FG='1' and tbl_BOSE_QUE.INWORK_FG='' and tbl_BOSE_LOCK.LOCK_ID is null;");

    if (@_flow_que_rec) {
      $_flow_process_id = @_flow_que_rec[0];
      $_flow_act_que_no = @_flow_que_rec[1];
      $_flow_lock_id = @_flow_que_rec[2];

      ## ߼¹Υץ鿷Ͽ줿QUEȥ꤫ɤΥå
      @_flow_stat_rec = $_flow_dbh->selectrow_array("select ERROR_DUMP, INWORK_FG, SCRIPT_NAME, TRACE_LOG from tbl_BOSE_PROC_STAT where PROCESS_ID='$_flow_process_id'");
      $_flow_error_dump = @_flow_stat_rec[0];
      $_flow_inwork = @_flow_stat_rec[1];
      $_flow_script_name = @_flow_stat_rec[2];
      $_flow_script_file = "$_flow_script_dir/$_flow_script_name.bin";
      $_flow_trace_log = @_flow_stat_rec[3];

      if (length($_flow_error_dump)>0) {

        ## ߼¹Υեץ˥顼ȯ
        $_flow_dbh->do("update tbl_BOSE_QUE set ACTIVATE_FG='' where PROCESS_ID='$_flow_process_id'");
        $_flow_dbh->do("unlock tables");
      } elsif (length($_flow_inwork)>0) {

        ## ߼¹Υեץˤ줿QUEȥξ
        $_flow_dbh->do("update tbl_BOSE_QUE set INWORK_FG='1' where PROCESS_ID='$_flow_process_id'");
        $_flow_dbh->do("update tbl_BOSE_PROC_STAT set INWORK_FG='1' where PROCESS_ID='$_flow_process_id'");
        $_flow_dbh->do("unlock tables");
      } else {

        ## ¹Բǽʥեץ
        $_flow_dbh->do("update tbl_BOSE_QUE set INWORK_FG='1' where PROCESS_ID='$_flow_process_id'");
        $_flow_dbh->do("update tbl_BOSE_PROC_STAT set INWORK_FG='1' where PROCESS_ID='$_flow_process_id'");

        ## LOCK_ID굯ưξ
        if (length($_flow_lock_id)) {
          $_flow_lock_id = $_flow_dbh->quote($_flow_lock_id);
          $_flow_dbh->do("replace tbl_BOSE_LOCK (LOCK_ID, CREATE_TIME) values ($_flow_lock_id, NOW())");
        }

        ## եץȤν
        if (length($_flow_trace_log)==0) {
          @_flow_script_rec = $_flow_dbh->selectrow_array("select SCRIPT_LEN from tbl_BOSE_WORKFLOW where SCRIPT_NAME='$_flow_script_name'");

          if ((-e $_flow_script_file)==0 || (-s $_flow_script_file)!=(@_flow_script_rec[0])) {
            @_flow_script_rec = $_flow_dbh->selectrow_array("select SCRIPT from tbl_BOSE_WORKFLOW where SCRIPT_NAME='$_flow_script_name'");

            open(SCRIPT_H, ">$_flow_script_file");
            print SCRIPT_H @_flow_script_rec[0];
            close(SCRIPT_H);
          }
        }

        $_flow_dbh->do("unlock tables");
  
        ## եץ³ΤSNAPSHOTե̾
        if ($_flow_snapshot_mode eq "file") {
          $_flow_snapshot_file= "$_flow_snapshot_file_prefix$_flow_process_id";

          ## եץ硢SNAPSHOTե¸ߤʤϤ
          if (length($_flow_trace_log)==0) {
            unlink($_flow_snapshot_file);
          }
        } else {
          ## DBSNAPSHOTǡ
          $_flow_snapshot_file = "-";
        }

        ## եץεư³

###(DEBUG) print "### echo $_flow_act_que_no | /usr/local/bose/bin/bose_exec $_flow_db_define_file $_flow_script_file $_flow_process_id $_flow_snapshot_file\n";

        system("cd /usr/local/bose; echo $_flow_act_que_no | /usr/local/bose/bin/bose_exec $_flow_db_define_file $_flow_script_file $_flow_process_id $_flow_snapshot_file &");
  
        ## ƥ٤ηڸ
        select undef, undef, undef, 0.01;
      }
    } else {
      ## ư³ǽʥեץ̵ä
      $_flow_dbh->do("unlock tables");
      $_flow_loop = 0;
    }
  }

  ## ƥ٤ηڸ
  select undef, undef, undef, 0.1;
}

